/* 
 * File:   Dotplot_Wrapper.hh
 * Author: TCO
 *
 * Created on 30. September 2009, 11:34
 */

#ifndef _DOTPLOT_WRAPPER_HH
#define	_DOTPLOT_WRAPPER_HH

#include "Input_Wrapper.hh"
#include <fstream>
#include <iostream>
#include <algorithm>


class Dotplot_Wrapper : public Input_Wrapper {
public:
    Dotplot_Wrapper(std::string fname);
    virtual ~Dotplot_Wrapper();
    std::string get_sequence();
    std::string get_seqID();
    basepair read_basepair();
    bool has_more_basepairs();
private:
    std::ifstream fileHandle_;
    std::string seq_id_;
    std::string sequence_;
    std::string seqname_from_filename(const std::string &s);
    void fetch_sequence();
    basepair next;
    bool ready;
    bool prepare_reading();


};

#endif	/* _DOTPLOT_WRAPPER_HH */

