/* 
 * File:   Fake_Input.cc
 * Author: TCO
 * 
 * Created on 29. September 2009, 11:46
 */

#include "Fake_Input.hh"
#include <time.h>
#include <math.h>

Fake_Input::Fake_Input() {
    srand(time(NULL));
    seq  = "ACGCTCGGGCCGCACGCTCG";
    arc_count = 30;
}

std::string Fake_Input::get_sequence(){
    return seq;
}

std::string Fake_Input::get_seqID(){
    return "sequenz ID";
}

bool Fake_Input::has_more_basepairs(){
    return arc_count >= 0;
}

basepair Fake_Input::read_basepair(){
    arc_count--;
    basepair bp;
    bp.left = 1 + rand() % seq.length();
    bp.right = 1 + rand() % seq.length();
    bp.prob =  rand() % 100 / 100.0 ;
    return bp;
}


Fake_Input::~Fake_Input() {
}

