/* 
 * File:   Input_Wrapper.hh
 * Author: TCO
 *
 * Interface for wrappers around various input formats.
 *
 * Created on 29. September 2009, 11:03
 */

#ifndef _INPUT_WRAPPER_HH
#define	_INPUT_WRAPPER_HH
#include <string>
#include <vector>
#include "base.hh"

struct basepair{
    size_t2 left;
    size_t2 right;
    double prob;
};

struct basecount{
    float A, C, G, U, GAP;
};

class Input_Wrapper{
public:
    virtual std::string get_seqID() = 0;     // return the input sequence identifier
    virtual std::string get_sequence() = 0;  // return the input sequence
    virtual size_t get_num_sequences(){ return 1; };  // return the number of sequences (in case of multiple alignments)
    virtual basepair read_basepair() = 0;    // read the next basepair. Can be unordered
    virtual bool has_more_basepairs() = 0;   // return true as long as new basepairs can be read from input
};


#endif	/* _INPUT_WRAPPER_HH */

