/* 
 * File:   Input_Writer.hh
 * Author: TCO
 *
 * Created on 29. September 2009, 11:16
 */

#ifndef _INPUT_WRITER_HH
#define	_INPUT_WRITER_HH

#include "Input_Wrapper.hh"
#include "base.hh"
#include <vector>
#include <string>
#include <ostream>

using namespace std;

class Input_Writer {
public:
    Input_Writer(Input_Wrapper &wrapper);
    bool write_to(std::ofstream &fileHandle);
    virtual ~Input_Writer();
private:
    Input_Wrapper &wrapper_;
    vector<string> sequence_;
    string  seq_ID_;
    size_t  num_seqs_;
    size_t2 num_arcs_;
    size_t2 seq_len_;
    size_t2 max_span_;
    vector< vector<basepair> > bp_;
    void fetch_basepairs();
};

#endif	/* _INPUT_WRITER_HH */

