/* 
 * File:   MultiDotplot_Wrapper.hh
 * Author: TCO
 *
 * Created on 11. Oktober 2009, 19:16
 */

#ifndef _MULTIDOTPLOT_WRAPPER_HH
#define	_MULTIDOTPLOT_WRAPPER_HH

#include "Input_Wrapper.hh"
#include <fstream>
#include <algorithm>
#include <iostream>
#include <algorithm>
#include <map>
#include <vector>

class MultiDotplot_Wrapper : public Input_Wrapper {
public:
    MultiDotplot_Wrapper(std::string fName1, std::string fName2);
    virtual ~MultiDotplot_Wrapper();
    std::string get_sequence();
    std::string get_seqID();
    size_t get_num_sequences();
    basepair read_basepair();
    bool has_more_basepairs();
private:
    std::ifstream *fasta_;
    std::ifstream *dotplot_;
    std::vector<std::string> sequences_;
    
    int i_;
    bool identify_file_types(const char* f1, const char* f2);
    void fetch_sequence();
    basepair next;
    bool ready;
    bool prepare_reading();
};

#endif	/* _MULTIDOTPLOT_WRAPPER_HH */

