/* 
 * File:   RNAplfold.cc
 * Author: TCO
 * 
 * Created on 22. Januar 2010, 19:09
 */


#include "RNAplfold.hh"

RNAplfold::RNAplfold(std::string file1, std::string file2) {
    fasta_ = NULL;
    basepairs_ = NULL;
    if (!identify_file_types(file1.c_str(), file2.c_str())){
        std::cerr << "Cannot identifies or read input files" << std::endl;
	std::exit(-1);
    }else{
        fetch_sequence();
        ready = true;
        read_basepair(); // Das erste Basepair muss fix eingelesen werden
    }
}



bool RNAplfold::identify_file_types(const char *f1, const char *f2){
    std::ifstream test(f1);
    std::string line;
    int a,b;
    double c;
    if (!test.good())
        return false;
    test >> line;
    if (line[0] == '>')
        fasta_ = new std::ifstream(f1);
    else /*if (line >> a >> b >> c)*/
        basepairs_ = new std::ifstream(f1);

    std::ifstream test2(f2);
    if (!test2.good())
        return false;
    test2 >> line;
    if (line[0] == '>')
        fasta_ = new std::ifstream(f2);
    else /*if (line >> a >> b >> c)*/
        basepairs_ = new std::ifstream(f2);

    return  ( (basepairs_ != NULL) && (fasta_ != NULL) );
}





basepair RNAplfold::read_basepair(){
    // The returned basepair will always be the one already read and labeled "next"!
    // We will read the following basepair from dotplot
    basepair bp;
    if (!ready){
        bp.left = 0;
        bp.right = 0;
        bp.prob = 0.0;
    }else{
        bp = next;

        size_t2 left, right;
        double prob;
	/*
	 * ACHTUNG! In the _basepairs format, baseprobs does not need to be squared
	 */

	if (*basepairs_ >> left >> right >> prob)  {      // Try to read the next bp
                next.left = left;
                next.right = right;
                next.prob = prob;    // Everything fine
        }
        else
            ready = false; // read FAILED = no basepairs left
    }
    return bp;
}



std::string RNAplfold::get_sequence(){
    return seq;
}

std::string RNAplfold::get_seqID(){
    return seqID;
}

bool RNAplfold::has_more_basepairs(){
    return ready;
}




void RNAplfold::fetch_sequence(){
    if (!fasta_->good()){
        fasta_->seekg(std::ios_base::beg); // Just in case assure that we read the file from beginning
        if (!fasta_->good()){
              std::cerr << "Fasta unreadable!" << std::endl;
              std::exit(-1);
        }
    }
    std::string tmp, tmp_seq;
    while (*fasta_ >> tmp){
        if (tmp[0] == '>')
            seqID = tmp.substr(1);
        else
            tmp_seq.append(tmp);
    }

    seq = tmp_seq;
}
