#ifndef BASE_HH
#define BASE_HH

//#define NDEBUG                        // Disable Assertions

#include <vector>
#include <cstddef>
#include <queue>
#include <string>
#include <cassert>

// using namespace std;



typedef int score_t;
typedef long size_t2;


struct matrix_entry{
    score_t score;
    size_t2 start;   // ich schleife einfach den AlignmentStartpunkt mit durch und spare somit das Backtracking
    char * alignment; // Experimental, soll das Alignment gleich mit aufbauen! (entspricht dem Array Index in einem grossen allokierten Char-Array.
    matrix_entry(): score(0), start(0), alignment(NULL) {};
    // TODO:  Wenn man sauber arbeiten will koennte man die Speicher allokierung und freigabe fuer den alignment string gleich hier reinpacken
};

struct result_type{
    size_t2 start;
    size_t2 stop;
    score_t score;
    short target_number;
    std::string alignment;
    //float zscore; // optional
};


//! represents a base pair; stores base pair left end, right end, and weight
struct Arc{
    size_t2 idx;
    size_t2 left;
    size_t2 right;
    score_t weight;
};

enum Base{
    A,
    C,
    G,
    U,
    T = U,
    N
};

	typedef std::vector<Arc> RightAdjList;
	typedef std::vector<Arc> LeftAdjList;


const int INFTY = 1000000000;

class Sequence;
typedef Sequence Sequence;

class BasePairs;
typedef BasePairs BasePairs;


typedef std::priority_queue<result_type, std::vector<result_type>, std::greater<result_type> > PriorityQueue;

inline bool operator> (const result_type& a, const result_type &b)
{
	return a.score > b.score;
}


inline bool operator< (const result_type& a, const result_type &b)
{
	return a.score < b.score;
}


#endif
